
/************************************************************************
 *
 * SR/Z3950 application software version 1.0, August 1993.
 *
 * (C) Software Kinetics Ltd.
 *
 * Software Kinetics Ltd. has granted a licence of this software to the
 * National Library of Canada.
 *
 * The National Library of Canada grants to the user a royalty-free
 * non-exclusive licence in perpetuity to use, modify, improve, reproduce
 * and sell the software.
 *
 * The software is provided to the user "as is" without warranty of any
 * kind. Neither Software Kinetics Ltd. nor the National Library of Canada
 * warrants, guarantees or makes any representations regarding the use,
 * or the results of use of the software in terms of accuracy, reliability,
 * or otherwise. The entire risk as to results and performance of the
 * software is assumed by the user. Neither Software Kinetics Ltd. nor the
 * National Library of Canada shall be liable for any direct, indirect,
 * consequential or incidental damages arising out of the use of the
 * software.
 *
 * $Log:
 * Revision 1.1  1993/09/16  09:03:27  irorigin
 * Baseline for Release 1.0.
 *
 ************************************************************************/

/*
 * asn_bits.h
 *
 * MS 92
 * Copyright (C) 1992 Michael Sample and the University of British Columbia
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * $Header: /mnt/users/irorigin/sdl/src/asn/headers/RCS/asn_bits.h,v 1.1 1993/03/17 20:40:54 irorigin Allocated irorigin $
 * $Log: asn_bits.h,v $
 * Revision 1.1  1993/03/17  20:40:54  irorigin
 * Initial revision
 *
 */


#ifndef _asn_bits_h_
#define _asn_bits_h_


typedef struct AsnBits
{
    int   bitLen;
    char* bits;
} AsnBits;

extern char numToHexCharTblG[];

#define TO_HEX(fourBits) (numToHexCharTblG[(fourBits) & 0x0f])


#define ASNBITS_PRESENT(abits) ((abits)->bits != NULL)


AsnLen BEncAsnBits PROTO((BUF_TYPE b, AsnBits* data));

void BDecAsnBits PROTO((BUF_TYPE b, AsnBits* result, AsnLen* bytesDecoded,
                       ENV_TYPE env));

AsnLen BEncAsnBitsContent PROTO((BUF_TYPE b, AsnBits* bits));

void BDecAsnBitsContent PROTO((BUF_TYPE    b,
                        AsnLen len,
                        AsnTag tagId,
                        AsnBits* result,
                        AsnLen* bytesDecoded,
                        ENV_TYPE env));

void FreeAsnBits PROTO((AsnBits* v));

void PrintAsnBits PROTO((FILE* f, AsnBits* b, unsigned short int indent));

int AsnBitsEquiv PROTO((AsnBits* b1, AsnBits* b2));

void SetAsnBit PROTO((AsnBits* b1, unsigned long int bit));

void ClrAsnBit PROTO((AsnBits* b1, unsigned long int bit));

int GetAsnBit PROTO((AsnBits* b1, unsigned long int bit));

#endif /* conditional include */
