
/************************************************************************
 *
 * SR/Z3950 application software version 1.0, August 1993.
 *
 * (C) Software Kinetics Ltd.
 *
 * Software Kinetics Ltd. has granted a licence of this software to the
 * National Library of Canada.
 *
 * The National Library of Canada grants to the user a royalty-free
 * non-exclusive licence in perpetuity to use, modify, improve, reproduce
 * and sell the software.
 *
 * The software is provided to the user "as is" without warranty of any
 * kind. Neither Software Kinetics Ltd. nor the National Library of Canada
 * warrants, guarantees or makes any representations regarding the use,
 * or the results of use of the software in terms of accuracy, reliability,
 * or otherwise. The entire risk as to results and performance of the
 * software is assumed by the user. Neither Software Kinetics Ltd. nor the
 * National Library of Canada shall be liable for any direct, indirect,
 * consequential or incidental damages arising out of the use of the
 * software.
 *
 * $Log:
 * Revision 1.1  1993/09/16  09:03:27  irorigin
 * Baseline for Release 1.0.
 *
 ************************************************************************/

/*
 * nibble_alloc.h - handles buffer allocation
 * MS 91
 *
 * Copyright (C) 1992 Michael Sample and the University of British Columbia
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * $Header: /mnt/users/irorigin/sdl/src/asn/headers/RCS/asn_nibl.h,v 1.1 1993/03/17 20:42:56 irorigin Allocated irorigin $
 * $Log: asn_nibl.h,v $
 * Revision 1.1  1993/03/17  20:42:56  irorigin
 * Initial revision
 *
 */

#ifndef _nibble_alloc_h_
#define _nibble_alloc_h_

typedef struct NibbleBuf
{
    char* start;
    char* end;
    char* curr;
    struct NibbleBuf* next;
} NibbleBuf;


typedef struct NibbleMem
{
    NibbleBuf* firstNibbleBuf;
    NibbleBuf* currNibbleBuf;
    unsigned long int incrementSize;
} NibbleMem;



void InitNibbleMem PROTO((unsigned long int initialSize,
                          unsigned long int incrementSize));

void ShutdownNibbleMem();

void ServiceNibbleFault PROTO((unsigned long int size));

void* NibbleAlloc PROTO((unsigned long int size));

void ResetNibbleMem();


#endif /* conditional include */
