
/************************************************************************
 *
 * SR/Z3950 application software version 1.0, August 1993.
 *
 * (C) Software Kinetics Ltd.
 *
 * Software Kinetics Ltd. has granted a licence of this software to the
 * National Library of Canada.
 *
 * The National Library of Canada grants to the user a royalty-free
 * non-exclusive licence in perpetuity to use, modify, improve, reproduce
 * and sell the software.
 *
 * The software is provided to the user "as is" without warranty of any
 * kind. Neither Software Kinetics Ltd. nor the National Library of Canada
 * warrants, guarantees or makes any representations regarding the use,
 * or the results of use of the software in terms of accuracy, reliability,
 * or otherwise. The entire risk as to results and performance of the
 * software is assumed by the user. Neither Software Kinetics Ltd. nor the
 * National Library of Canada shall be liable for any direct, indirect,
 * consequential or incidental damages arising out of the use of the
 * software.
 *
 * $Log:
 * Revision 1.1  1993/09/16  09:03:27  irorigin
 * Baseline for Release 1.0.
 *
 ************************************************************************/


#ifndef ASN_TOOLS_H
#define ASN_TOOLS_H

#include <ir.h>
#include <asn/asn_incl.h>

/* 
 * Macros
 */
#define ASN_LIST_SET_FIRST(list) (list)->curr = (list)->first
#define ASN_LIST_SET_LAST(list) (list)->curr = (list)->last
#define ASN_LIST_SET_NEXT(list) (list)->curr = (list)->curr->next
#define ASN_LIST_CUR(list) (list)->curr
#define ASN_LIST_GET(list) (list)->curr->data
#define ASN_LIST_INIT(list)\
	{\
		(list)->first = NULL;\
		(list)->last = NULL;\
		(list)->curr = NULL;\
	}
#define ASN_LIST_SIZE(list) (list)->count

AsnOcts *ASN_OctsCreate();
SHORT ASN_OctsAdd(AsnOcts *octs, char *buf, ULONG count);
SHORT ASN_OctsCopy(AsnOcts *destOcts, AsnOcts *srcOcts);
SHORT ASN_OctsDelete(AsnOcts *delOcts);
SHORT ASN_OctsGet(char **buf, ULONG *count, AsnOcts *octs);
SHORT ASN_BitsAdd(AsnBits *bits, char *buf, USHORT count);
SHORT ASN_BitsCopy(AsnBits *destBits, AsnBits *srcBits);
SHORT ASN_BitsDelete(AsnBits *delBits);
SHORT ASN_BitsGet(char **buf, USHORT *byteCnt, USHORT *bitCnt, AsnBits *bits);

SHORT ASN_DottedStringToOid(AsnOid *oidEntry, CHAR *dottedString, USHORT len);
void ASN_AsnOidToDottedString(AsnOid *oidEntry, CHAR *dottedString);
SHORT ASN_OidCopy(AsnOid *destOid, AsnOid *srcOid);

AsnList 	*ASN_ListCreate(USHORT sizeOfDataElem);
IR_STATUS 	ASN_ListAppend(AsnList *list, void *data);
void		*ASN_ListDelete(AsnList *list, SHORT pos);
void		ASN_ListSetPos(AsnList *list, SHORT pos);

IR_STATUS	RescASN_IRToSnaccVS(CHAR *srcFile, AsnOcts *octs, 
		    VISIBLE_STRING *vs);
IR_STATUS	RescASN_IRToSnaccOS(CHAR *srcFile, AsnOcts *octs, 
		    OCTET_STRING *os);
IR_STATUS	RescASN_IRToSnaccBS(CHAR *srcFile, AsnBits *bits, 
		    BIT_STRING *bs);
IR_STATUS	RescASN_IRToSnaccOI(CHAR *srcFile, AsnOid *oid, 
		    OBJECT_IDENTIFIER *oi);

IR_STATUS	RescASN_SnaccToIRVS(CHAR *srcFile, VISIBLE_STRING *vs, 
		    AsnOcts *octs);
IR_STATUS	RescASN_SnaccToIROS(CHAR *srcFile, OCTET_STRING *os, 
		    AsnOcts *octs);
IR_STATUS	RescASN_SnaccToIRBS(CHAR *srcFile, BIT_STRING *bs, 
		    AsnBits *bits);
IR_STATUS	RescASN_SnaccToIROI(CHAR *srcFile, OBJECT_IDENTIFIER *oi, 
		    AsnOid *oid);

IR_EXTERNAL	*RescASN_CreateExternal(CHAR *srcFile);
IR_STATUS	RescASN_DestroyExternal(CHAR *srcFile, IR_EXTERNAL *irExt);
IR_STATUS	RescASN_IRToSnaccExternal(CHAR *srcFile, EXTERNAL *snaccElem,
		    IR_EXTERNAL *irElem);
IR_STATUS	RescASN_SnaccToIRExternal(CHAR *srcFile, IR_EXTERNAL *irExt,
		    EXTERNAL *snaccExt);

#endif 
