
/************************************************************************
 *
 * SR/Z3950 application software version 1.0, August 1993.
 *
 * (C) Software Kinetics Ltd.
 *
 * Software Kinetics Ltd. has granted a licence of this software to the
 * National Library of Canada.
 *
 * The National Library of Canada grants to the user a royalty-free
 * non-exclusive licence in perpetuity to use, modify, improve, reproduce
 * and sell the software.
 *
 * The software is provided to the user "as is" without warranty of any
 * kind. Neither Software Kinetics Ltd. nor the National Library of Canada
 * warrants, guarantees or makes any representations regarding the use,
 * or the results of use of the software in terms of accuracy, reliability,
 * or otherwise. The entire risk as to results and performance of the
 * software is assumed by the user. Neither Software Kinetics Ltd. nor the
 * National Library of Canada shall be liable for any direct, indirect,
 * consequential or incidental damages arising out of the use of the
 * software.
 *
 * $Log:
 * Revision 1.1  1993/09/16  09:03:27  irorigin
 * Baseline for Release 1.0.
 *
 ************************************************************************/


#ifndef DEBUG_H
#define DEBUG_H
#include <ir.h>
#include <stdio.h>
#include <fcntl.h>


CHAR 	*RescIR_ExpandFile(int, char *);

#define IR_FILE (RescIR_ExpandFile(__LINE__, __FILE__))


#define RESC_UT_LOG_TMP_FILE		"/tmp/irlog"

void RescUT_DebugPrintS(CHAR *, CHAR *);
void RescUT_DebugPrintV(CHAR *, CHAR *, ULONG);
void RescUT_DebugTrace(CHAR *, CHAR *);
void RescUT_DebugInit();

#define CS_LOG_PRINTS(loc, string)	\
	RescUT_DebugPrintS(loc, string);

#define CS_LOG_PRINTV(loc, fmt, param)	\
	RescUT_DebugPrintV((CHAR *)loc, (CHAR *)fmt, (ULONG)param);

#define CS_LOG_OPEN 					\
	RescUT_DebugInit();
#define CS_LOG_TRACES(loc, string)			\
	RescUT_DebugTrace(loc, string);
#endif
