
/************************************************************************
 *
 * SR/Z3950 application software version 1.0, August 1993.
 *
 * (C) Software Kinetics Ltd.
 *
 * Software Kinetics Ltd. has granted a licence of this software to the
 * National Library of Canada.
 *
 * The National Library of Canada grants to the user a royalty-free
 * non-exclusive licence in perpetuity to use, modify, improve, reproduce
 * and sell the software.
 *
 * The software is provided to the user "as is" without warranty of any
 * kind. Neither Software Kinetics Ltd. nor the National Library of Canada
 * warrants, guarantees or makes any representations regarding the use,
 * or the results of use of the software in terms of accuracy, reliability,
 * or otherwise. The entire risk as to results and performance of the
 * software is assumed by the user. Neither Software Kinetics Ltd. nor the
 * National Library of Canada shall be liable for any direct, indirect,
 * consequential or incidental damages arising out of the use of the
 * software.
 *
 * $Log:
 * Revision 1.1  1993/09/16  09:03:27  irorigin
 * Baseline for Release 1.0.
 *
 ************************************************************************/

#ifndef RESC_IO_H
#define RESC_IO_H

#define RESC_IO_TAG_LENGTH 	4
#define RESC_IO_STATUS_LENGTH	1
#define RESC_IO_KEY_LENGTH	80
#define RESC_IO_LEN_LENGTH	10
#define RESC_IO_MAX_RECORD_SIZE	4000

#define RESC_IO_MAX_FILE_NAME_SIZE 80

#define RESC_IO_REC_OK 		"0"
#define RESC_IO_REC_DELETED	"1" 

typedef CHAR *RESC_IO_TAG_TYPE;

#define RESC_IO_USER_INFO	"A1A1"	
#define RESC_IO_TARGET_INFO	"A2A2"
#define RESC_IO_DATABASE_INFO	"A3A3" 

typedef struct
{
	FILE		*fp;
	VISIBLE_STRING 	name;
	BOOLEAN		eof;
	BOOLEAN		isMalloced;
} RESC_IO_FILE_STRUCT;

IR_STATUS RescIO_OpenFile(CHAR *srcFile, VISIBLE_STRING workPath,
			VISIBLE_STRING fileName, RESC_IO_FILE_STRUCT *file);
IR_STATUS RescIO_CloseFile(CHAR *srcFile, RESC_IO_FILE_STRUCT *file);
IR_STATUS RescIO_Seek(CHAR *srcFile, RESC_IO_FILE_STRUCT *file, 
			RESC_IO_TAG_TYPE tag, VISIBLE_STRING *key, 
		 	fpos_t *recStatus);
IR_STATUS RescIO_GetRecord(CHAR *srcFile, RESC_IO_FILE_STRUCT file,
			VISIBLE_STRING **record);
IR_STATUS RescIO_DeleteRecord(CHAR *srcFile, RESC_IO_FILE_STRUCT file,
			fpos_t recStatus);
IR_STATUS RescIO_AddRecord(CHAR *srcFile, RESC_IO_FILE_STRUCT file,
			VISIBLE_STRING tag, VISIBLE_STRING key,
			VISIBLE_STRING record);	
BOOLEAN	  RescIO_EOF(RESC_IO_FILE_STRUCT file);
IR_STATUS RescIO_GetRecPtr(CHAR *srcFile, RESC_IO_FILE_STRUCT file, 
			fpos_t *recPtr);
IR_STATUS RescIO_SetRecPtr(CHAR *srcFile, RESC_IO_FILE_STRUCT file, 
			fpos_t recPtr);
#endif
